#
#  File: php.spec
#  $Author: bjn $
#  $Revision: 1.1.2.3 $
#  $Date: 2000/05/30 22:45:24 $
#
#  This is the SPEC file for the Horde-customized PHP RPMs/SRPM
#

%define mysql 1
%define freetype 1
%define snmp 0
%define mcrypt 0

Summary: The PHP HTML-embedded scripting language for use with Apache.
Name: php
Version: 3.0.16
Release: 5horde7
Vendor: The Horde Project
URL: http://www.horde.org/
Packager: Brent J. Nordquist <bjn@horde.org>
Group: System Environment/Daemons
Source0: http://www.php.net/distributions/php-%{version}.tar.gz
#Icon: php3.gif
Patch1:    php-3.0.16-config.patch
Patch2:    imap_fetchheader.patch
Copyright: GPL
BuildRoot: %{_tmppath}/%{name}-root
Prereq: apache >= 1.3.12-2
Obsoletes: mod_php3
BuildPrereq: apache-devel
%if %{freetype}
BuildPrereq: freetype-devel
%endif
%if %{snmp}
BuildPrereq: ucd-snmp-devel
%endif
%if %{mcrypt}
BuildPrereq: mcrypt-devel
%endif

%description
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most common
use of PHP coding is probably as a replacement for CGI scripts.  The
mod_php module enables the Apache web server to understand and process
the embedded PHP language in web pages.

This package contains PHP version 3.0.  If you use applications which
specifically rely on PHP/FI (PHP v2 and earlier), you should instead
install the PHP/FI module contained in the phpfi package.  If you're
just starting with PHP, you should install this package.  You'll also
need to install the Apache web server.

[Note:  These PHP packages have been customized for use in the Horde
project (http://www.horde.org/); relevant PHP bugs have been fixed and
the MySQL support has been enabled.]

%package manual
Obsoletes: mod_php3-manual
Group: System Environment/Daemons
Summary: The manual for PHP3, in HTML format.
Prereq: php = %{version}

%description manual
The php-manual package provides comprehensive documentation for the
PHP3 HTML-embedded scripting language, in HTML format.

[Note:  These PHP packages have been customized for use in the Horde
project (http://www.horde.org/); relevant PHP bugs have been fixed and
the MySQL support has been enabled.]

%package pgsql
Group: System Environment/Daemons
Prereq: php = %{version}
Summary: A PostgreSQL database module for PHP3.
Prereq: /usr/bin/perl
Provides: php_database
Obsoletes: mod_php3-pgsql
BuildPrereq: postgresql-devel

%description pgsql
The php-pgsql package includes a dynamic shared object (DSO) that can
be compiled in to the Apache Web server to add PostgreSQL database
support to PHP3.  PostgreSQL is an object-relational database
management system that supports almost all SQL constructs. PHP is an
HTML-embedded scripting language. If you need back-end support for
PostgreSQL, you should install this package in addition to the main
php package.

[Note:  These PHP packages have been customized for use in the Horde
project (http://www.horde.org/); relevant PHP bugs have been fixed and
the MySQL support has been enabled.]

%if %{mysql}
%package mysql
Group: System Environment/Daemons
Requires: php = %{version}
Summary: A MySQL database module for PHP3.
Prereq: /usr/bin/perl
Provides: php_database
Obsoletes: mod_php3-mysql
BuildPrereq: MySQL-devel

%description mysql
The php-mysql package includes a dynamic shared object (DSO) that can
be compiled in to the Apache Web server to add MySQL database
support to PHP3.  MySQL is a true multi-user, multi-threaded SQL
database server. PHP is an HTML-embedded scripting language. If you
need back-end support for MySQL, you should install this package in
addition to the main php package.

[Note:  These PHP packages have been customized for use in the Horde
project (http://www.horde.org/); relevant PHP bugs have been fixed and
the MySQL support has been enabled.]
%endif

%package imap
Group: System Environment/Daemons
Prereq: php = %{version}
Requires: krb5-libs, pam
Obsoletes: mod_php3-imap
Prereq: /usr/bin/perl
Summary: An IMAP module for PHP3.
BuildPrereq: imap-devel, krb5-libs, pam

%description imap
The php-imap package contains a dynamic shared object (DSO) for the
Apache Web server.  The php-imap module, when compiled into Apache,
that will add IMAP (Internet Message Access Protocol) support to
PHP3. IMAP is a protocol for retrieving and uploading e-mail messages
on mail servers. PHP is an HTML-embedded scripting language for use
with Apache.  If you need IMAP support for PHP3 applications, you will
need to install this package and PHP3.

[Note:  These PHP packages have been customized for use in the Horde
project (http://www.horde.org/); relevant PHP bugs have been fixed and
the MySQL support has been enabled.]

%package ldap
Group: System Environment/Daemons
Prereq: php = %{version}
Summary: An Apache Web server module for PHP3 applications that use LDAP.
BuildPrereq: openldap-devel

%description ldap
The php-ldap package is a dynamic shared object (DSO) for the Apache
Web server that adds Lightweight Directory Access Protocol (LDAP)
support to PHP3. LDAP is a set of protocols for accessing directory
services over the Internet. PHP3 is an HTML-embedded scripting
language. If you need LDAP support for PHP3 applications, you will
need to install this package in addition to the php package.

[Note:  These PHP packages have been customized for use in the Horde
project (http://www.horde.org/); relevant PHP bugs have been fixed and
the MySQL support has been enabled.]

%prep
%setup -q -n php-%{version}
%patch1 -p1 -b .config
%patch2 -p1 -b .orig

%build
autoconf
CFLAGS="-fPIC" ./configure --prefix=%{_prefix} \
	--with-apxs=%{_prefix}/sbin/apxs \
	--with-config-file-path=/etc/httpd \
	--enable-safe-mode \
	--with-exec-dir=%{_prefix}/bin \
	--with-system-regex \
	--disable-debug \
	--with-zlib \
	--with-gdbm \
	--with-db2 \
%if %{freetype}
	--with-freetype \
%else
	--without-freetype \
%endif
%if %{snmp}
	--with-snmp \
%else
	--without-snmp \
%endif
%if %{mcrypt}
	--with-mcrypt \
%else
	--without-mcrypt \
%endif
	--enable-debugger \
	--enable-magic-quotes \
	--enable-track-vars \
	--enable-sysvsem \
	--enable-sysvshm \
	--enable-track-vars \
	--with-xml \
	--with-ftp

make
make -C convertor

# PostgreSQL module
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 -DHAVE_PQCMDTUPLES \
	-I. -I/usr/include/apache \
	-I/usr/include/pgsql -o pgsql.so \
	./functions/pgsql.c -lpq -lc

# MySQL module
%if %{mysql}
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 \
	-I. -I/usr/include/apache \
	-I/usr/include/mysql -o mysql.so \
	./functions/mysql.c -L/usr/lib/mysql -lmysqlclient -lc
%endif

# IMAP module
perl -pi -e 's/HAVE_IMAP 0/HAVE_IMAP 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 \
	-I. -I/usr/include/apache \
	-I/usr/include/imap -o imap.so ./functions/imap.c \
	/usr/lib/c-client.a \
	-L/usr/kerberos/lib -lgssapi_krb5 -lkrb5 -lk5crypto -lcom_err \
	-lpam -ldl -lc

# LDAP module
perl -pi -e 's/HAVE_LDAP 0/HAVE_LDAP 1/g' config.h
gcc -shared -fPIC $RPM_OPT_FLAGS -DEAPI -DCOMPILE_DL=1 \
	-I. -I/usr/include/apache \
	-o ldap.so ./functions/ldap.c -lldap -llber -lc

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/php3
mkdir -p $RPM_BUILD_ROOT/usr/lib/apache
mkdir -p $RPM_BUILD_ROOT/etc/httpd
mkdir -p $RPM_BUILD_ROOT/home/httpd/icons
mkdir -p $RPM_BUILD_ROOT/usr/bin
install -m 755 -s libphp3.so $RPM_BUILD_ROOT/usr/lib/apache/
install -m 755 -s pgsql.so $RPM_BUILD_ROOT/usr/lib/php3/
%if %{mysql}
install -m 755 -s mysql.so $RPM_BUILD_ROOT/usr/lib/php3/
%endif
install -m 755 -s imap.so $RPM_BUILD_ROOT/usr/lib/php3/
install -m 755 -s ldap.so $RPM_BUILD_ROOT/usr/lib/php3/
install -m 644 php3.ini-dist $RPM_BUILD_ROOT/etc/httpd/php3.ini
install -m 644 extra/icons/*.gif $RPM_BUILD_ROOT/home/httpd/icons/
install -m 755 convertor/convertor $RPM_BUILD_ROOT/usr/bin/
mv convertor/README convertor/README.convertor

# manual
mkdir -p $RPM_BUILD_ROOT/home/httpd/html/manual/mod/mod_php3
cp doc/*.html $RPM_BUILD_ROOT/home/httpd/html/manual/mod/mod_php3
cd $RPM_BUILD_ROOT/home/httpd/html/manual/mod/mod_php3
ln -sf manual.html index.html

%clean
rm -rf $RPM_BUILD_ROOT

%post
perl -pi -e 's|^#LoadModule php3_module|LoadModule php3_module|g' \
	/etc/httpd/conf/httpd.conf
perl -pi -e 's|^#AddModule mod_php3.c|AddModule mod_php3.c|g' \
	/etc/httpd/conf/httpd.conf
#perl -pi -e \
#	's|^#AddIcon /icons/php3.gif .php3|AddIcon /icons/php3.gif .php3|g' \
#	/etc/httpd/conf/httpd.conf

%preun
if [ $1 = 0 ] ; then
    perl -pi -e 's|^LoadModule php3_module|#LoadModule php3_module|g' \
	/etc/httpd/conf/httpd.conf
    perl -pi -e 's|^AddModule mod_php3.c|#AddModule mod_php3.c|g' \
	/etc/httpd/conf/httpd.conf
#    perl -pi -e \
#	's|^AddIcon /icons/php3.gif .php3|#AddIcon /icons/php3.gif .php3|g' \
#	/etc/httpd/conf/httpd.conf
fi

%triggerpostun -- php <= 3.0.15-1
perl -pi -e 's|^#LoadModule php3_module|LoadModule php3_module|g' \
	/etc/httpd/conf/httpd.conf
perl -pi -e 's|^#AddModule mod_php3.c|AddModule mod_php3.c|g' \
	/etc/httpd/conf/httpd.conf
#perl -pi -e \
#	's|^#AddIcon /icons/php3.gif .php3|AddIcon /icons/php3.gif .php3|g' \
#	/etc/httpd/conf/httpd.conf

%post imap
perl -pi -e 's|^;extension=imap.so|extension=imap.so|g' /etc/httpd/php3.ini

%preun imap
if [ $1 = 0 -a -r /etc/httpd/php3.ini ]; then
  perl -pi -e 's|^extension=imap.so|;extension=imap.so|g' /etc/httpd/php3.ini
fi

%post pgsql
perl -pi -e 's|^;extension=pgsql.so|extension=pgsql.so|g' /etc/httpd/php3.ini

%preun pgsql
if [ $1 = 0 -a -r /etc/httpd/php3.ini ]; then
  perl -pi -e 's|^extension=pgsql.so|;extension=pgsql.so|g' /etc/httpd/php3.ini
fi

%if %{mysql}
%post mysql
perl -pi -e 's|^;extension=mysql.so|extension=mysql.so|g' /etc/httpd/php3.ini

%preun mysql
if [ $1 = 0 -a -r /etc/httpd/php3.ini ]; then
  perl -pi -e 's|^extension=mysql.so|;extension=mysql.so|g' /etc/httpd/php3.ini
fi
%endif

%post ldap
perl -pi -e 's|^;extension=ldap.so|extension=ldap.so|g'  /etc/httpd/php3.ini

%preun ldap
if [ $1 = 0 -a -r /etc/httpd/php3.ini ]; then
  perl -pi -e 's|^extension=ldap.so|;extension=ldap.so|g' /etc/httpd/php3.ini
fi

%files
%defattr(-,root,root)
/usr/lib/apache/libphp3.so
%config /etc/httpd/php3.ini
/home/httpd/icons/*
/usr/bin/convertor
%doc CODING_STANDARDS CREDITS ChangeLog LICENSE BUGS examples
%doc INSTALL* CHANGES COPYING
%doc convertor/README.convertor

%files pgsql
%defattr(-,root,root)
/usr/lib/php3/pgsql.so

%if %{mysql}
%files mysql
%defattr(-,root,root)
/usr/lib/php3/mysql.so
%endif

%files imap
%defattr(-,root,root)
/usr/lib/php3/imap.so

%files ldap
%defattr(-,root,root)
/usr/lib/php3/ldap.so

%files manual
%defattr(-,root,root)
/home/httpd/html/manual/mod/mod_php3

%changelog
* Tue May 16 2000 Nalin Dahyabhai <nalin@redhat.com>
- link IMAP module against GSS-API and PAM to get dependencies right
- change most of the Requires to Prereqs, because the post edits config files
- move the PHP *Apache* module back to the right directory
- fix broken postun trigger that broke the post
- change most of the postuns to preuns in case php gets removed before subpkgs

* Thu May 11 2000 Trond Eivind Glomsrd <teg@redhat.com>
- rebuilt against new postgres libraries

* Tue May 09 2000 Preston Brown <pbrown@redhat.com>
- php3 .so modules moved to /usr/lib/php3 from /usr/lib/apache (was incorrect)

* Mon Apr 10 2000 Nalin Dahyabhai <nalin@redhat.com>
- make subpackages require php = %{version} (bug #10671)

* Thu Apr 06 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 3.0.16

* Fri Mar 03 2000 Cristian Gafton <gafton@redhat.com>
- fixed the post script to work when upgrading a package
- add triggere to fix the older packages

* Tue Feb 29 2000 Nalin Dahyabhai <nalin@redhat.com>
- update to 3.0.15
- add build-time dependency for openldap-devel
- enable db,ftp,shm,sem support to fix bug #9648

* Fri Feb 25 2000 Nalin Dahyabhai <nalin@redhat.com>
- add dependency for imap subpackage
- rebuild against Apache 1.3.12

* Thu Feb 24 2000 Preston Brown <pbrown@redhat.com>
- don't include old, outdated manual.  package one from the php distribution.

* Tue Feb 01 2000 Cristian Gafton <gafton@redhat.com>
- rebuild to fix dependency problem

* Fri Jan 14 2000 Preston Brown <pbrown@redhat.com>
- added commented out mysql module, thanks to Jason Duerstock 
  (jason@sdi.cluephone.com). Uncomment to build if you have mysql installed.

* Thu Jan 13 2000 Preston Brown <pbrown@redhat.com>
- rely on imap-devel, don't include imap in src.rpm (#5099).
- xml enabled (#5393)

* Tue Nov 02 1999 Preston Brown <pborwn@redhat.com>
- added post/postun sections to modify httpd.conf (#5259)
- removed old obsolete faq and gif (#5260)
- updated manual.tar.gz package (#5261)

* Thu Oct 07 1999 Matt Wilson <msw@redhat.com>
- rebuilt for sparc glibc brokenness

* Fri Sep 24 1999 Preston Brown <pbrown@redhat.com>
- --with-apxs --> --with-apxs=/usr/sbin/apxs (# 5094)
- ldap support (# 5097)

* Thu Sep 23 1999 Preston Brown <pbrown@redhat.com>
- fix cmdtuples for postgresql, I had it slightly wrong

* Tue Aug 31 1999 Bill Nottingham <notting@redhat.com>
- subpackages must obsolete old stuff...

* Sun Aug 29 1999 Preston Brown <pbrown@redhat.com>
- added -DHAVE_PGCMDTUPLES for postgresql module (bug # 4767)

* Fri Aug 27 1999 Preston Brown <pbrown@redhat.com>
- name change to php to follow real name of package
- fix up references to php3 to refer to php
- upgrade to 3.0.12
- fixed typo in pgsql postun script (bug # 4686)

* Mon Jun 14 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.9
- fixed postgresql module and made separate package
- separated manual into separate documentation package

* Mon May 24 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.8, which fixes problems with glibc 2.1.
- took some ideas grom Gomez's RPM.

* Tue May 04 1999 Preston Brown <pbrown@redhat.com>
- hacked in imap support in an ugly way until imap gets an official
  shared library implementation

* Fri Apr 16 1999 Preston Brown <pbrown@redhat.com>
- pick up php3.ini

* Wed Mar 24 1999 Preston Brown <pbrown@redhat.com>
- build against apache 1.3.6

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Mon Mar 08 1999 Preston Brown <pbrown@redhat.com>
- upgraded to 3.0.7.

* Wed Feb 24 1999 Preston Brown <pbrown@redhat.com>
- Injected new description and group.

* Sun Feb 07 1999 Preston Brown <pbrown@redhat.com>
- upgrade to php 3.0.6, built against apache 1.3.4

* Mon Oct 12 1998 Cristian Gafton <gafton@redhat.com>
- rebuild for apache 1.3.3

* Thu Oct 08 1998 Preston Brown <pbrown@redhat.com>
- updated to 3.0.5, fixes nasty bugs in 3.0.4.

* Sun Sep 27 1998 Cristian Gafton <gafton@redhat.com>
- updated to 3.0.4 and recompiled for apache 1.3.2

* Thu Sep 03 1998 Preston Brown <pbrown@redhat.com>
- improvements; builds with apache-devel package installed.

* Tue Sep 01 1998 Preston Brown <pbrown@redhat.com>
- Made initial cut for PHP3.
